diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityWolfEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityWolfEntry.java
new file mode 100644
index 000000000..3cc3a7c9e
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityWolfEntry.java
@@ -0,0 +1,169 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.entity;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.modelviewer.GuiModelViewer;
+import net.minecraft.client.gui.modelviewer.elements.GuiListSelectorButton;
+import net.minecraft.client.gui.modelviewer.elements.GuiListenerButton;
+import net.minecraft.client.gui.modelviewer.elements.GuiTextCycle;
+import net.minecraft.core.entity.animal.EntityWolf;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.material.ArmorMaterial;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class EntityWolfEntry extends EntityEntry<EntityWolf>{
+    private static final List<ArmorMaterial> armorMaterials = new ArrayList<>(EntityWolf.ARMOR_MATERIALS.keySet());
+    static {
+        armorMaterials.add(null);
+    }
+
+    @Override
+    public void onTick(EntityWolf entity) {
+
+    }
+
+    @Override
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, EntityWolf entityWolf) {
+        List<GuiButton> buttonList = new ArrayList<>();
+        boolean isTamed = entityWolf.isWolfTamed();
+        GuiListenerButton tamed = new GuiListenerButton(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.wolf.button.tamed", isTamed));
+        tamed.setActionListener(() -> {
+            boolean _tamed = !entityWolf.isWolfTamed();
+            entityWolf.setWolfTamed(_tamed);
+            tamed.displayString = I18n.getInstance().translateKeyAndFormat("model.category.entity.wolf.button.tamed", _tamed);
+        });
+
+        boolean isSitting = entityWolf.isWolfSitting();
+        GuiListenerButton sitting = new GuiListenerButton(-1, - 120, tamed.yPosition + 21, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.wolf.button.sitting", isSitting));
+        sitting.setActionListener(() -> {
+            boolean _sitting = !entityWolf.isWolfSitting();
+            entityWolf.setWolfSitting(_sitting);
+            sitting.displayString = I18n.getInstance().translateKeyAndFormat("model.category.entity.wolf.button.sitting", _sitting);
+        });
+
+        boolean isAngry = entityWolf.isWolfAngry();
+        GuiListenerButton angry = new GuiListenerButton(-1, - 120, sitting.yPosition + 21, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.wolf.button.angry", isAngry));
+        angry.setActionListener(() -> {
+            boolean _angry = !entityWolf.isWolfAngry();
+            entityWolf.setWolfAngry(_angry);
+            angry.displayString = I18n.getInstance().translateKeyAndFormat("model.category.entity.wolf.button.angry", _angry);
+        });
+
+        GuiListSelectorButton<ArmorMaterial> armor = new GuiListSelectorButton<ArmorMaterial>(-1, - 120, angry.yPosition + 21, 120, 20, I18n.getInstance().translateKey("model.category.entity.wolf.button.armor"), armorMaterials,null) {
+            @Override
+            public String getNameFromElement(ArmorMaterial element) {
+                return element == null ? "none" : element.name;
+            }
+        };
+        armor.setActionListener(() -> {
+            ArmorMaterial material = armor.getCurrentElement();
+            entityWolf.getEntityData().set(19, material == null ? "" : material.name);
+        });
+
+        entityWolf.setWolfHeldItem(null);
+        GuiListenerButton hasItem = new GuiListenerButton(-1, - 120, armor.yPosition + 21, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.wolf.button.item", false));
+
+        GuiTextCycle<Integer> itemIdCycle = new GuiTextCycle<Integer>(parentScreen, mc.fontRenderer, - 120, hasItem.yPosition + 21, 120, 20, 1) {
+            @Override
+            public Integer cycleElement(Integer current, int offset) {
+                return GuiModelViewer.cycleItemId(current, offset);
+            }
+
+            @Override
+            public Integer getElementFromString(String s) {
+                try {
+                    int id = Integer.parseInt(s);
+                    if (Item.itemsList[id] != null) return id;
+                } catch (Exception ignored){}
+                if (entityWolf.getWolfHeldItem() != null){
+                    return entityWolf.getWolfHeldItem().itemID;
+                }
+                return 0;
+            }
+
+            @Override
+            public String getNameFromElement(Integer element) {
+                return String.valueOf(element);
+            }
+        };
+        itemIdCycle.enabled = false;
+        itemIdCycle.textField.setPrefaceText("ID: ");
+        itemIdCycle.textField.setPlaceholder("Item ID");
+
+        GuiTextCycle<Integer> metaCycle = new GuiTextCycle<Integer>(parentScreen, mc.fontRenderer, - 120, itemIdCycle.yPosition + 21, 120, 20, 0) {
+            @Override
+            public Integer cycleElement(Integer current, int offset) {
+                return (current + offset) & 0x3FFF;
+            }
+
+            @Override
+            public Integer getElementFromString(String s) {
+                try {
+                    int id = Integer.parseInt(s);
+                    return MathHelper.clamp(id, 0, 0x3FFF);
+                } catch (Exception ignored){}
+                if (entityWolf.getWolfHeldItem() != null){
+                    return entityWolf.getWolfHeldItem().getMetadata();
+                }
+                return 0;
+            }
+
+            @Override
+            public String getNameFromElement(Integer element) {
+                return String.valueOf(element);
+            }
+        };
+        metaCycle.enabled = false;
+        metaCycle.textField.setPrefaceText("Meta: ");
+        metaCycle.textField.setPlaceholder("Meta");
+
+        itemIdCycle.setOnValueChanged(() -> entityWolf.setWolfHeldItem(new ItemStack(itemIdCycle.getCurrentElement(), 1, metaCycle.getCurrentElement())));
+        metaCycle.setOnValueChanged(() -> entityWolf.setWolfHeldItem(new ItemStack(itemIdCycle.getCurrentElement(), 1, metaCycle.getCurrentElement())));
+        hasItem.setActionListener(() -> {
+            boolean _hasItem = entityWolf.getWolfHeldItem() != null;
+            if (_hasItem){
+                entityWolf.setWolfHeldItem(null);
+                itemIdCycle.enabled = false;
+                metaCycle.enabled = false;
+            } else {
+                entityWolf.setWolfHeldItem(new ItemStack(itemIdCycle.getCurrentElement(), 1, metaCycle.getCurrentElement()));
+                itemIdCycle.enabled = true;
+                metaCycle.enabled = true;
+            }
+            hasItem.displayString = I18n.getInstance().translateKeyAndFormat("model.category.entity.wolf.button.item", !_hasItem);
+        });
+
+        buttonList.add(tamed);
+        buttonList.add(sitting);
+        buttonList.add(angry);
+        buttonList.add(armor);
+        buttonList.add(hasItem);
+        buttonList.add(itemIdCycle);
+        buttonList.add(metaCycle);
+        return buttonList;
+    }
+
+    @Override
+    public EntityWolf getEntityInstance(Minecraft mc, World world) {
+        EntityWolf wolf = new EntityWolf(world);
+        wolf.setWolfHeldItem(null);
+        return wolf;
+    }
+
+    @Override
+    public void onOpen() {
+
+    }
+
+    @Override
+    public void onClose() {
+
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/BlockFXEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/BlockFXEntry.java
new file mode 100644
index 000000000..10fcb96ff
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/BlockFXEntry.java
@@ -0,0 +1,92 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.particle;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.entity.fx.EntityDiggingFX;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.modelviewer.GuiModelViewer;
+import net.minecraft.client.gui.modelviewer.elements.GuiTextCycle;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+
+import java.util.List;
+
+public class BlockFXEntry extends GenericFXEntry{
+    protected int blockId;
+    protected int meta;
+
+    public BlockFXEntry() {
+        super("block");
+    }
+
+    @Override
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen) {
+        List<GuiButton> buttonList = super.getEntryButtons(mc, parentScreen);
+        GuiTextCycle<Integer> blockIdCycle = new GuiTextCycle<Integer>(parentScreen, mc.fontRenderer, - 120, buttonList.get(buttonList.size()-1).yPosition + 21, 120, 20, blockId) {
+            @Override
+            public Integer cycleElement(Integer current, int offset) {
+                return GuiModelViewer.cycleBlockId(current, offset);
+            }
+
+            @Override
+            public Integer getElementFromString(String s) {
+                try {
+                    int id = Integer.parseInt(s);
+                    return MathHelper.clamp(id, 0, Item.itemsList.length);
+                } catch (Exception ignored){}
+                return blockId;
+            }
+
+            @Override
+            public String getNameFromElement(Integer element) {
+                return String.valueOf(element);
+            }
+        };
+        blockIdCycle.textField.setPrefaceText("ID: ");
+        blockIdCycle.textField.setPlaceholder("Block ID");
+        blockIdCycle.setOnValueChanged(() -> blockId = blockIdCycle.getCurrentElement());
+        buttonList.add(blockIdCycle);
+
+        GuiTextCycle<Integer> metaCycle = new GuiTextCycle<Integer>(parentScreen, mc.fontRenderer, - 120, blockIdCycle.yPosition + 21, 120, 20, 0) {
+            @Override
+            public Integer cycleElement(Integer current, int offset) {
+                return (current + offset) & 0x3FFF;
+            }
+
+            @Override
+            public Integer getElementFromString(String s) {
+                try {
+                    int id = Integer.parseInt(s);
+                    return MathHelper.clamp(id, 0, 0x3FFF);
+                } catch (Exception ignored){}
+                return meta;
+            }
+
+            @Override
+            public String getNameFromElement(Integer element) {
+                return String.valueOf(element);
+            }
+        };
+        metaCycle.textField.setPrefaceText("Meta: ");
+        metaCycle.textField.setPlaceholder("Meta");
+        metaCycle.setOnValueChanged(() -> meta = metaCycle.getCurrentElement());
+        buttonList.add(metaCycle);
+
+        return buttonList;
+    }
+
+    @Override
+    public void spawnParticle(Minecraft mc, World world, double x, double y, double z) {
+        mc.effectRenderer.addEffect(new EntityDiggingFX(world, x, y, z, motionX,motionY,motionZ, Block.getBlock(blockId), Side.BOTTOM.getId(), meta));
+    }
+
+    @Override
+    public void onOpen() {
+        blockId = 1;
+    }
+
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/BubbleFXEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/BubbleFXEntry.java
new file mode 100644
index 000000000..46a8587b5
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/BubbleFXEntry.java
@@ -0,0 +1,15 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.particle;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.entity.fx.EntityBubbleFX;
+import net.minecraft.core.world.World;
+
+public class BubbleFXEntry extends GenericFXEntry{
+    public BubbleFXEntry() {
+        super("bubble");
+    }
+    @Override
+    public void spawnParticle(Minecraft mc, World world, double x, double y, double z) {
+        mc.effectRenderer.addEffect(new EntityBubbleFX(world, x, y, z, motionX, motionY, motionZ, false));
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/GenericFXEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/GenericFXEntry.java
new file mode 100644
index 000000000..0dde12094
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/GenericFXEntry.java
@@ -0,0 +1,82 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.particle;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.modelviewer.elements.GuiListenerTextField;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.world.World;
+
+import java.util.ArrayList;
+import java.util.List;
+import java.util.Objects;
+
+public class GenericFXEntry extends ParticleEntry{
+    public final String particleID;
+    protected final String overrideName;
+    protected double motionX;
+    protected double motionY;
+    protected double motionZ;
+
+    public GenericFXEntry(String particleID){
+        this(particleID, null);
+    }
+    public GenericFXEntry(String particleID, String overrideName){
+        this.particleID = Objects.requireNonNull(particleID);
+        this.overrideName = overrideName;
+    }
+    @Override
+    public String getParticleName(I18n translator) {
+        if (overrideName != null){
+            return overrideName;
+        }
+        return particleID;
+    }
+
+    @Override
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen) {
+        List<GuiButton> buttons = new ArrayList<>();
+        GuiListenerTextField mxField = new GuiListenerTextField(parentScreen, mc.fontRenderer, -120, 0, 120, 20, String.valueOf(motionX), "Motion X");
+        mxField.setPrefaceText("Motion X: ");
+        mxField.setOnValueChanged(() ->{
+            try {
+                motionX = Double.parseDouble(mxField.getText());
+            } catch (Exception ignored){}
+        });
+        GuiListenerTextField myField = new GuiListenerTextField(parentScreen, mc.fontRenderer, -120, mxField.yPosition + 21, 120, 20, String.valueOf(motionY), "Motion Y");
+        myField.setPrefaceText("Motion Y: ");
+        myField.setOnValueChanged(() ->{
+            try {
+                motionY = Double.parseDouble(myField.getText());
+            } catch (Exception ignored){}
+        });
+        GuiListenerTextField mzField = new GuiListenerTextField(parentScreen, mc.fontRenderer, -120, myField.yPosition + 21, 120, 20, String.valueOf(motionZ), "Motion Z");
+        mzField.setPrefaceText("Motion Z: ");
+        mzField.setOnValueChanged(() ->{
+            try {
+                motionZ = Double.parseDouble(mzField.getText());
+            } catch (Exception ignored){}
+        });
+        buttons.add(mxField);
+        buttons.add(myField);
+        buttons.add(mzField);
+        return buttons;
+    }
+
+    @Override
+    public void spawnParticle(Minecraft mc, World world, double x, double y, double z) {
+        world.spawnParticle(particleID, x, y, z, motionX, motionY, motionZ);
+    }
+
+    @Override
+    public void onOpen() {
+        motionX = 0;
+        motionY = 0;
+        motionZ = 0;
+    }
+
+    @Override
+    public void onClose() {
+
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ItemFXEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ItemFXEntry.java
new file mode 100644
index 000000000..be56276f7
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ItemFXEntry.java
@@ -0,0 +1,80 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.particle;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.entity.fx.EntityItemFX;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.modelviewer.elements.GuiTextCycle;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class ItemFXEntry extends ParticleEntry{
+    protected int itemID;
+    @Override
+    public String getParticleName(I18n translator) {
+        return "item";
+    }
+
+    @Override
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen) {
+        GuiTextCycle<Integer> itemIdCycle = new GuiTextCycle<Integer>(parentScreen, mc.fontRenderer, - 120, 0, 120, 20, itemID) {
+            @Override
+            public Integer cycleElement(Integer current, int offset) {
+                return cycleItemId(current, offset);
+            }
+
+            @Override
+            public Integer getElementFromString(String s) {
+                try {
+                    int id = Integer.parseInt(s);
+                    return MathHelper.clamp(id, 0, Item.itemsList.length);
+                } catch (Exception ignored){}
+                return itemID;
+            }
+
+            @Override
+            public String getNameFromElement(Integer element) {
+                return String.valueOf(element);
+            }
+        };
+        itemIdCycle.textField.setPrefaceText("ID: ");
+        itemIdCycle.textField.setPlaceholder("Item ID");
+        itemIdCycle.setOnValueChanged(() -> itemID = itemIdCycle.getCurrentElement());
+        return new ArrayList<GuiButton>(){
+            {
+                add(itemIdCycle);
+            }
+        };
+    }
+
+    @Override
+    public void spawnParticle(Minecraft mc, World world, double x, double y, double z) {
+        mc.effectRenderer.addEffect(new EntityItemFX(world, x, y, z, Item.itemsList[itemID]));
+    }
+
+    @Override
+    public void onOpen() {
+        itemID = 16384;
+    }
+
+    @Override
+    public void onClose() {
+
+    }
+    private int cycleItemId(int itemId, int offset){
+        int numItems = Item.itemsList.length - Block.blocksList.length;
+
+        int _itemId = MathHelper.clamp(itemId - numItems, 0, numItems);
+        int id = (_itemId + numItems + offset) % numItems;
+        while (Item.itemsList[id + Block.blocksList.length] == null){
+            id = (id + (int) Math.signum(offset) + numItems) % numItems;
+        }
+        return id + Block.blocksList.length;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/LeafFXEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/LeafFXEntry.java
new file mode 100644
index 000000000..fd9ebfdef
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/LeafFXEntry.java
@@ -0,0 +1,15 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.particle;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.entity.fx.EntityLeafFX;
+import net.minecraft.core.world.World;
+
+public class LeafFXEntry extends GenericFXEntry{
+    public LeafFXEntry() {
+        super("fallingleaf");
+    }
+    @Override
+    public void spawnParticle(Minecraft mc, World world, double x, double y, double z) {
+        mc.effectRenderer.addEffect(new EntityLeafFX(world, x, y, z, motionX, motionY, motionZ));
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/NoteFXEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/NoteFXEntry.java
new file mode 100644
index 000000000..6df504b4b
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/NoteFXEntry.java
@@ -0,0 +1,49 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.particle;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.entity.fx.EntityNoteFX;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.world.World;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class NoteFXEntry extends ParticleEntry{
+    protected int note = 0;
+    protected final int maxNote = 24;
+    @Override
+    public String getParticleName(I18n translator) {
+        return "note";
+    }
+
+    @Override
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen) {
+        GuiListenerSlider noteSlider = new GuiListenerSlider(-1, -120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.particle.note.slider", getNoteString(note)), ((float)note)/maxNote);
+        noteSlider.setOnValueChanged(() ->{
+            note = (int) (noteSlider.sliderValue * maxNote);
+            noteSlider.displayString = I18n.getInstance().translateKeyAndFormat("model.category.particle.note.slider", getNoteString(note));
+        });
+        return new ArrayList<GuiButton>(){{add(noteSlider);}};
+    }
+    private String getNoteString(int note){
+        return (Integer.toHexString(note).length() == 1) ? "0"+Integer.toHexString(note) : Integer.toHexString(note);
+    }
+
+    @Override
+    public void spawnParticle(Minecraft mc, World world, double x, double y, double z) {
+        mc.effectRenderer.addEffect(new EntityNoteFX(world, x, y, z, (double) note / 24D, 0.0D, 0.0D));
+    }
+
+    @Override
+    public void onOpen() {
+        note = 0;
+    }
+
+    @Override
+    public void onClose() {
+
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntry.java
new file mode 100644
index 000000000..95d6b8a76
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntry.java
@@ -0,0 +1,17 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.particle;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.world.World;
+
+import java.util.List;
+
+public abstract class ParticleEntry {
+    public abstract String getParticleName(I18n translator);
+    public abstract List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen);
+    public abstract void spawnParticle(Minecraft mc, World world, double x, double y, double z);
+    public abstract void onOpen();
+    public abstract void onClose();
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/RedDustFXEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/RedDustFXEntry.java
new file mode 100644
index 000000000..896e066a2
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/RedDustFXEntry.java
@@ -0,0 +1,88 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.particle;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.entity.fx.EntityReddustFX;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.modelviewer.elements.GuiListenerTextField;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.world.World;
+import org.lwjgl.input.Keyboard;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class RedDustFXEntry extends ParticleEntry{
+    private int red = 0;
+    private int green = 0;
+    private int blue = 0;
+    @Override
+    public String getParticleName(I18n translator) {
+        return "reddust";
+    }
+
+    @Override
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen) {
+        GuiListenerTextField rField = new GuiListenerTextField(parentScreen, mc.fontRenderer, -120, 0, 40, 20, String.valueOf(red), "Red");
+        rField.setPrefaceText("R: ");
+        rField.setKeyListener(key -> {
+            try {
+                red = Integer.parseInt(rField.getText());
+            } catch (Exception ignored){}
+        });
+        rField.setActionListener(() -> {
+            if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL)){
+                rField.setText(String.valueOf(0));
+                red = 0;
+            }
+        });
+        GuiListenerTextField gField = new GuiListenerTextField(parentScreen, mc.fontRenderer, -80, 0, 40, 20, String.valueOf(green), "Green");
+        gField.setPrefaceText("G: ");
+        gField.setKeyListener(key -> {
+            try {
+                green = Integer.parseInt(gField.getText());
+            } catch (Exception ignored){}
+        });
+        gField.setActionListener(() -> {
+            if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL)){
+                gField.setText(String.valueOf(0));
+                green = 0;
+            }
+        });
+        GuiListenerTextField bField = new GuiListenerTextField(parentScreen, mc.fontRenderer, -40, 0, 40, 20, String.valueOf(blue), "Blue");
+        bField.setPrefaceText("B: ");
+        bField.setKeyListener(key -> {
+            try {
+                blue = Integer.parseInt(bField.getText());
+            } catch (Exception ignored){}
+        });
+        bField.setActionListener(() -> {
+            if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL)){
+                bField.setText(String.valueOf(0));
+                blue = 0;
+            }
+        });
+        return new ArrayList<GuiButton>(){{
+            add(rField);
+            add(gField);
+            add(bField);
+        }};
+    }
+
+    @Override
+    public void spawnParticle(Minecraft mc, World world, double x, double y, double z) {
+        mc.effectRenderer.addEffect(new EntityReddustFX(world, x, y, z, red/255f, green/255f, blue/255f));
+    }
+
+    @Override
+    public void onOpen() {
+        red = 0;
+        green = 0;
+        blue = 0;
+    }
+
+    @Override
+    public void onClose() {
+
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListSelectorButton.java b/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListSelectorButton.java
new file mode 100644
index 000000000..5d7bb9166
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListSelectorButton.java
@@ -0,0 +1,47 @@
+package net.minecraft.client.gui.modelviewer.elements;
+
+import net.minecraft.client.Minecraft;
+import org.lwjgl.input.Keyboard;
+
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.List;
+
+public abstract class GuiListSelectorButton<T> extends GuiListenerButton{
+    public final List<T> list;
+    private int index;
+    private final String formattedText;
+    private final T defaultElement;
+    public GuiListSelectorButton(int id, int xPosition, int yPosition, int width, int height, String formattedText, Collection<T> collection, T initialElement) {
+        super(id, xPosition, yPosition, width, height, "");
+        displayString = String.format(formattedText, getNameFromElement(initialElement));
+        this.defaultElement = initialElement;
+        this.formattedText = formattedText;
+        this.list = new ArrayList<>(collection);
+        this.index = this.list.indexOf(initialElement);
+    }
+    @Override
+    public void onClick(Minecraft mc, int mouseX, int mouseY) {
+        if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL)){
+            resetValue();
+        } else {
+            offsetId(Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) ? -1 : 1);
+        }
+        displayString = String.format(formattedText, getNameFromElement(getCurrentElement()));
+        super.onClick(mc, mouseX, mouseY);
+    }
+    public T getCurrentElement(){
+        return list.get(index);
+    }
+    private void offsetId(int offset){
+        int _index = index;
+        index = (index + list.size() + offset) % list.size();
+        if (_index != index){
+            onValueChanged();
+        }
+    }
+    public void resetValue(){
+        index = list.indexOf(defaultElement);
+    }
+    public abstract String getNameFromElement(T element);
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerButton.java b/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerButton.java
new file mode 100644
index 000000000..547793dfb
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerButton.java
@@ -0,0 +1,61 @@
+package net.minecraft.client.gui.modelviewer.elements;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiButton;
+
+public class GuiListenerButton extends GuiButton implements IListenerElement {
+    protected IActionListener action;
+    protected IKeyListener keyListener;
+    protected Runnable onValueChanged;
+    public GuiListenerButton(int id, int xPosition, int yPosition, String text) {
+        super(id, xPosition, yPosition, text);
+    }
+
+    public GuiListenerButton(int id, int xPosition, int yPosition, int width, int height, String text) {
+        super(id, xPosition, yPosition, width, height, text);
+    }
+    @Override
+    public boolean mouseClicked(Minecraft mc, int mouseX, int mouseY) {
+        boolean flag = super.mouseClicked(mc, mouseX, mouseY);
+        if (flag){
+            onClick(mc, mouseX, mouseY);
+        }
+        return flag;
+    }
+    protected void onClick(Minecraft mc, int mouseX, int mouseY){
+        if (action != null){
+            action.onInteract();
+            onValueChanged();
+        }
+    }
+    @Override
+    public void setActionListener(IActionListener listener) {
+        action = listener;
+    }
+
+    @Override
+    public void setKeyListener(IKeyListener listener) {
+        keyListener = listener;
+    }
+    @Override
+    public void setOnValueChanged(Runnable runnable){
+        onValueChanged = runnable;
+    }
+
+    @Override
+    public void onKeyTyped(char c, int key) {
+        if (keyListener != null){
+            keyListener.onKeyPressed(key);
+        }
+    }
+
+    @Override
+    public void onValueChanged() {
+        if (onValueChanged != null){
+            onValueChanged.run();
+        }
+    }
+    public void tick(){
+
+    }
+}
